/**
 * 主要作用：圆盘摇奖
 * @author guozhenyao
 *  */

(function(window, vx, undefined) {'use strict';
	var directive = {};
	directive.uiDiscdraw = ['$compile',
	function($compile) {
		return {
			
			restrict : 'CA',
			scope :{
				actionrun : '&',
				randomnum : '@'
			},
			link : function(scope, element, attrs) {
				
				var $this = $('#luckdraw');
			
				enableStartBtn();

				/**
				 *主体逻辑
				 *  */
				function run() {
					var promise = scope.actionrun();
					promise.then(function(){
						disabledStartBtn();
						$this.find(".discbg").stopRotate();
						var StopInfo = getStopInfo();
						runRotate(StopInfo.angle, StopInfo.resultStr);
					});
					
				}
				

				/**
				 *初始化开始按钮的状态
				 *  */
				function enableStartBtn() {
					$this.find(".draw-btn").addClass("hover").bind('click', run);
					$("#popguize_bg").css('display','none'); 
					$("#popLottery_bg").css('display','none'); 
					//$("#popguize").show();
					//$("#popguize").removeAttr("disabled");
				}

				function disabledStartBtn() {
					$this.find(".draw-btn").removeClass("hover").unbind();
					
					$("#popguize_bg").css('display','block'); 
					$("#popLottery_bg").css('display','block'); 
					//$("#popguize").hide();
					//$("#popguize").attr("disabled",true);
				}

				/**
				 * 获取一定范围内随机的数字
				 * startIndex:范围的最小值(包括这个值)
				 * endIndex:范围的最大值（包括这个值）
				 *  */
				function getRan(startIndex, endIndex) {
					return parseInt(Math.random() * (endIndex - startIndex + 1) + startIndex,10);
				}

				function getStopInfo() {
					var index = getRan(0, 10);
					var StopInfo = {
						angle : index,
						resultStr : ""
					};
				
					StopInfo.angle =360 - (  36 * parseInt(scope.randomnum))+18;
					
					return StopInfo;
				}

				function showResult(resultStr) {
					$('.qiandao-active').fadeIn();
				}

				/**
				 *运行转动
				 * angle:停止的角度
				 * resultStr:提示的结果信息
				 *  */
				function runRotate(angle, resultStr) {
					$this.find(".discbg").rotate({
						angle : 0,
						animateTo : angle + 1440,
						duration : 10000,
						callback : function() {
							enableStartBtn();
							showResult(resultStr);
						}
					});
				}


				$this.find('.resultTip').find('a').bind('click', function() {
					$this.find('.resultTip').hide();
					$this.find('.cover').hide();
				});
				
				$(".close_prize").bind('click',function(){
					$('.qiandao-active').fadeOut();
				});
			}
		};
	}];
	vx.module('ibsapp').directive(directive);
})(window, window.vx);
